Package org.opencv.img_hash

## Class Img_hash

- java.lang.Object
- - org.opencv.img_hash.Img_hash

-     public class Img_hash
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `BLOCK_MEAN_HASH_MODE_0` |
    `static int` | `BLOCK_MEAN_HASH_MODE_1` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Img_hash()` |

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static void` | `averageHash​(Mat inputArr, Mat outputArr)` | Calculates img_hash::AverageHash in one call
    `static void` | `blockMeanHash​(Mat inputArr, Mat outputArr)` | Computes block mean hash of the input image
    `static void` | `blockMeanHash​(Mat inputArr, Mat outputArr, int mode)` | Computes block mean hash of the input image
    `static void` | `colorMomentHash​(Mat inputArr, Mat outputArr)` | Computes color moment hash of the input, the algorithm is come from the paper "Perceptual Hashing for Color Images Using Invariant Moments"
    `static void` | `marrHildrethHash​(Mat inputArr, Mat outputArr)` | Computes average hash value of the input image
    `static void` | `marrHildrethHash​(Mat inputArr, Mat outputArr, float alpha)` | Computes average hash value of the input image
    `static void` | `marrHildrethHash​(Mat inputArr, Mat outputArr, float alpha, float scale)` | Computes average hash value of the input image
    `static void` | `pHash​(Mat inputArr, Mat outputArr)` | Computes pHash value of the input image
    `static void` | `radialVarianceHash​(Mat inputArr, Mat outputArr)` | Computes radial variance hash of the input image
    `static void` | `radialVarianceHash​(Mat inputArr, Mat outputArr, double sigma)` | Computes radial variance hash of the input image
    `static void` | `radialVarianceHash​(Mat inputArr, Mat outputArr, double sigma, int numOfAngleLine)` | Computes radial variance hash of the input image

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### BLOCK_MEAN_HASH_MODE_0

          public static final int BLOCK_MEAN_HASH_MODE_0

      See Also:
        Constant Field Values

    - #### BLOCK_MEAN_HASH_MODE_1

          public static final int BLOCK_MEAN_HASH_MODE_1

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Img_hash

          public Img_hash()

  - ### Method Detail

    - #### radialVarianceHash

          public static void radialVarianceHash​(Mat inputArr,
                                                Mat outputArr,
                                                double sigma,
                                                int numOfAngleLine)

      Computes radial variance hash of the input image
      Parameters:
        `inputArr` - input image want to compute hash value, type should be CV_8UC4, CV_8UC3, CV_8UC1.
        `outputArr` - Hash value of input
        `sigma` - Gaussian kernel standard deviation
        `numOfAngleLine` - The number of angles to consider

    - #### radialVarianceHash

          public static void radialVarianceHash​(Mat inputArr,
                                                Mat outputArr,
                                                double sigma)

      Computes radial variance hash of the input image
      Parameters:
        `inputArr` - input image want to compute hash value, type should be CV_8UC4, CV_8UC3, CV_8UC1.
        `outputArr` - Hash value of input
        `sigma` - Gaussian kernel standard deviation

    - #### radialVarianceHash

          public static void radialVarianceHash​(Mat inputArr,
                                                Mat outputArr)

      Computes radial variance hash of the input image
      Parameters:
        `inputArr` - input image want to compute hash value, type should be CV_8UC4, CV_8UC3, CV_8UC1.
        `outputArr` - Hash value of input

    - #### pHash

          public static void pHash​(Mat inputArr,
                                   Mat outputArr)

      Computes pHash value of the input image
      Parameters:
        `inputArr` - input image want to compute hash value, type should be CV_8UC4, CV_8UC3, CV_8UC1.
        `outputArr` - Hash value of input, it will contain 8 uchar value

    - #### marrHildrethHash

          public static void marrHildrethHash​(Mat inputArr,
                                              Mat outputArr,
                                              float alpha,
                                              float scale)

      Computes average hash value of the input image
      Parameters:
        `inputArr` - input image want to compute hash value, type should be CV_8UC4, CV_8UC3, CV_8UC1.
        `outputArr` - Hash value of input, it will contain 16 hex decimal number, return type is CV_8U
        `alpha` - int scale factor for marr wavelet (default=2).
        `scale` - int level of scale factor (default = 1)

    - #### marrHildrethHash

          public static void marrHildrethHash​(Mat inputArr,
                                              Mat outputArr,
                                              float alpha)

      Computes average hash value of the input image
      Parameters:
        `inputArr` - input image want to compute hash value, type should be CV_8UC4, CV_8UC3, CV_8UC1.
        `outputArr` - Hash value of input, it will contain 16 hex decimal number, return type is CV_8U
        `alpha` - int scale factor for marr wavelet (default=2).

    - #### marrHildrethHash

          public static void marrHildrethHash​(Mat inputArr,
                                              Mat outputArr)

      Computes average hash value of the input image
      Parameters:
        `inputArr` - input image want to compute hash value, type should be CV_8UC4, CV_8UC3, CV_8UC1.
        `outputArr` - Hash value of input, it will contain 16 hex decimal number, return type is CV_8U

    - #### blockMeanHash

          public static void blockMeanHash​(Mat inputArr,
                                           Mat outputArr,
                                           int mode)

      Computes block mean hash of the input image
      Parameters:
        `inputArr` - input image want to compute hash value, type should be CV_8UC4, CV_8UC3 or CV_8UC1.
        `outputArr` - Hash value of input, it will contain 16 hex decimal number, return type is CV_8U
        `mode` - the mode

    - #### blockMeanHash

          public static void blockMeanHash​(Mat inputArr,
                                           Mat outputArr)

      Computes block mean hash of the input image
      Parameters:
        `inputArr` - input image want to compute hash value, type should be CV_8UC4, CV_8UC3 or CV_8UC1.
        `outputArr` - Hash value of input, it will contain 16 hex decimal number, return type is CV_8U

    - #### averageHash

          public static void averageHash​(Mat inputArr,
                                         Mat outputArr)

      Calculates img_hash::AverageHash in one call
      Parameters:
        `inputArr` - input image want to compute hash value, type should be CV_8UC4, CV_8UC3 or CV_8UC1.
        `outputArr` - Hash value of input, it will contain 16 hex decimal number, return type is CV_8U

    - #### colorMomentHash

          public static void colorMomentHash​(Mat inputArr,
                                             Mat outputArr)

      Computes color moment hash of the input, the algorithm is come from the paper "Perceptual Hashing for Color Images Using Invariant Moments"
      Parameters:
        `inputArr` - input image want to compute hash value, type should be CV_8UC4, CV_8UC3 or CV_8UC1.
        `outputArr` - 42 hash values with type CV_64F(double)